diff --git a/arch/arm/Kconfig b/arch/arm/Kconfig
index 9777dd6d4d9a..c70ce73bea12 100644
--- a/arch/arm/Kconfig
+++ b/arch/arm/Kconfig
@@ -346,7 +346,7 @@ config SYS_CACHELINE_SIZE
 choice
 	prompt "Select the ARM data write cache policy"
 	default SYS_ARM_CACHE_WRITETHROUGH if TARGET_BCMCYGNUS || \
-					      TARGET_BCMNSP || CPU_PXA || RZA1
+					      CPU_PXA || RZA1
 	default SYS_ARM_CACHE_WRITEBACK
 
 config SYS_ARM_CACHE_WRITEBACK
@@ -667,10 +667,6 @@ config TARGET_BCMCYGNUS
 	imply HASH_VERIFY
 	imply NETDEVICES
 
-config TARGET_BCMNSP
-	bool "Support bcmnsp"
-	select CPU_V7A
-
 config TARGET_BCMNS2
 	bool "Support Broadcom Northstar2"
 	select ARM64
@@ -1922,8 +1918,6 @@ source "board/cortina/presidio-asic/Kconfig"
 source "board/broadcom/bcm963158/Kconfig"
 source "board/broadcom/bcm968360bg/Kconfig"
 source "board/broadcom/bcm968580xref/Kconfig"
-source "board/broadcom/bcmcygnus/Kconfig"
-source "board/broadcom/bcmnsp/Kconfig"
 source "board/broadcom/bcmns3/Kconfig"
 source "board/cavium/thunderx/Kconfig"
 source "board/cirrus/edb93xx/Kconfig"
diff --git a/board/broadcom/bcm911360_entphn-ns/MAINTAINERS b/board/broadcom/bcm911360_entphn-ns/MAINTAINERS
deleted file mode 100644
index 8b831d8cb7a5..000000000000
--- a/board/broadcom/bcm911360_entphn-ns/MAINTAINERS
+++ /dev/null
@@ -1,6 +0,0 @@
-BCM911360_ENTPHN-NS BOARD
-M:	Steve Rae <steve.rae@raedomain.com>
-S:	Maintained
-F:	board/broadcom/bcmcygnus/
-F:	include/configs/bcm_ep_board.h
-F:	configs/bcm911360_entphn-ns_defconfig
diff --git a/board/broadcom/bcm911360_entphn/MAINTAINERS b/board/broadcom/bcm911360_entphn/MAINTAINERS
deleted file mode 100644
index d4f6aefe4885..000000000000
--- a/board/broadcom/bcm911360_entphn/MAINTAINERS
+++ /dev/null
@@ -1,6 +0,0 @@
-BCM911360_ENTPHN BOARD
-M:	Steve Rae <steve.rae@raedomain.com>
-S:	Maintained
-F:	board/broadcom/bcmcygnus/
-F:	include/configs/bcm_ep_board.h
-F:	configs/bcm911360_entphn_defconfig
diff --git a/board/broadcom/bcm911360k/MAINTAINERS b/board/broadcom/bcm911360k/MAINTAINERS
deleted file mode 100644
index 32e60327cfc3..000000000000
--- a/board/broadcom/bcm911360k/MAINTAINERS
+++ /dev/null
@@ -1,6 +0,0 @@
-BCM911360K BOARD
-M:	Steve Rae <steve.rae@raedomain.com>
-S:	Maintained
-F:	board/broadcom/bcmcygnus/
-F:	include/configs/bcm_ep_board.h
-F:	configs/bcm911360k_defconfig
diff --git a/board/broadcom/bcm958300k-ns/MAINTAINERS b/board/broadcom/bcm958300k-ns/MAINTAINERS
deleted file mode 100644
index 237d3446292b..000000000000
--- a/board/broadcom/bcm958300k-ns/MAINTAINERS
+++ /dev/null
@@ -1,6 +0,0 @@
-BCM958300K-NS BOARD
-M:	Steve Rae <steve.rae@raedomain.com>
-S:	Maintained
-F:	board/broadcom/bcmcygnus/
-F:	include/configs/bcm_ep_board.h
-F:	configs/bcm958300k-ns_defconfig
diff --git a/board/broadcom/bcm958300k/MAINTAINERS b/board/broadcom/bcm958300k/MAINTAINERS
deleted file mode 100644
index bbb6d64e1f06..000000000000
--- a/board/broadcom/bcm958300k/MAINTAINERS
+++ /dev/null
@@ -1,6 +0,0 @@
-BCM958300K BOARD
-M:	Steve Rae <steve.rae@raedomain.com>
-S:	Maintained
-F:	board/broadcom/bcmcygnus/
-F:	include/configs/bcm_ep_board.h
-F:	configs/bcm958300k_defconfig
diff --git a/board/broadcom/bcm958305k/MAINTAINERS b/board/broadcom/bcm958305k/MAINTAINERS
deleted file mode 100644
index 5ca0effc00d3..000000000000
--- a/board/broadcom/bcm958305k/MAINTAINERS
+++ /dev/null
@@ -1,6 +0,0 @@
-BCM958305K BOARD
-M:	Steve Rae <steve.rae@raedomain.com>
-S:	Maintained
-F:	board/broadcom/bcmcygnus/
-F:	include/configs/bcm_ep_board.h
-F:	configs/bcm958305k_defconfig
diff --git a/board/broadcom/bcm958622hr/MAINTAINERS b/board/broadcom/bcm958622hr/MAINTAINERS
deleted file mode 100644
index de44dd115985..000000000000
--- a/board/broadcom/bcm958622hr/MAINTAINERS
+++ /dev/null
@@ -1,6 +0,0 @@
-BCM958622HR BOARD
-M:	Steve Rae <steve.rae@raedomain.com>
-S:	Maintained
-F:	board/broadcom/bcmnsp/
-F:	include/configs/bcm_ep_board.h
-F:	configs/bcm958622hr_defconfig
diff --git a/board/broadcom/bcmcygnus/Kconfig b/board/broadcom/bcmcygnus/Kconfig
deleted file mode 100644
index faba4cf82b1f..000000000000
--- a/board/broadcom/bcmcygnus/Kconfig
+++ /dev/null
@@ -1,15 +0,0 @@
-if TARGET_BCMCYGNUS
-
-config SYS_BOARD
-	default "bcm_ep"
-
-config SYS_VENDOR
-	default "broadcom"
-
-config SYS_SOC
-	default "bcmcygnus"
-
-config SYS_CONFIG_NAME
-	default "bcm_ep_board"
-
-endif
diff --git a/board/broadcom/bcmnsp/Kconfig b/board/broadcom/bcmnsp/Kconfig
deleted file mode 100644
index a975082355a4..000000000000
--- a/board/broadcom/bcmnsp/Kconfig
+++ /dev/null
@@ -1,15 +0,0 @@
-if TARGET_BCMNSP
-
-config SYS_BOARD
-	default "bcm_ep"
-
-config SYS_VENDOR
-	default "broadcom"
-
-config SYS_SOC
-	default "bcmnsp"
-
-config SYS_CONFIG_NAME
-	default "bcm_ep_board"
-
-endif
diff --git a/configs/bcm911360_entphn-ns_defconfig b/configs/bcm911360_entphn-ns_defconfig
deleted file mode 100644
index b24edc36d763..000000000000
--- a/configs/bcm911360_entphn-ns_defconfig
+++ /dev/null
@@ -1,30 +0,0 @@
-CONFIG_ARM=y
-CONFIG_TARGET_BCMCYGNUS=y
-CONFIG_SYS_TEXT_BASE=0x61000000
-CONFIG_NR_DRAM_BANKS=1
-CONFIG_ENV_SIZE=0x2000
-CONFIG_SYS_EXTRA_OPTIONS="SYS_SDRAM_SIZE=0x20000000,ARMV7_NONSEC"
-# CONFIG_AUTOBOOT is not set
-# CONFIG_DISPLAY_CPUINFO is not set
-# CONFIG_DISPLAY_BOARDINFO is not set
-CONFIG_HUSH_PARSER=y
-CONFIG_CMD_BOOTZ=y
-CONFIG_CMD_ASKENV=y
-CONFIG_CMD_MX_CYCLIC=y
-# CONFIG_CMD_SETEXPR is not set
-CONFIG_CMD_MII=y
-CONFIG_CMD_PING=y
-CONFIG_CMD_CACHE=y
-CONFIG_CMD_TIME=y
-CONFIG_CMD_FAT=y
-CONFIG_ENV_OVERWRITE=y
-CONFIG_SYS_RELOC_GD_ENV_ADDR=y
-CONFIG_VERSION_VARIABLE=y
-CONFIG_BOUNCE_BUFFER=y
-# CONFIG_MMC is not set
-CONFIG_PHY_BROADCOM=y
-CONFIG_CONS_INDEX=3
-CONFIG_SYS_NS16550=y
-CONFIG_SHA1=y
-CONFIG_SHA256=y
-CONFIG_OF_LIBFDT=y
diff --git a/configs/bcm911360_entphn_defconfig b/configs/bcm911360_entphn_defconfig
deleted file mode 100644
index daeb8691a695..000000000000
--- a/configs/bcm911360_entphn_defconfig
+++ /dev/null
@@ -1,30 +0,0 @@
-CONFIG_ARM=y
-CONFIG_TARGET_BCMCYGNUS=y
-CONFIG_SYS_TEXT_BASE=0x61000000
-CONFIG_NR_DRAM_BANKS=1
-CONFIG_ENV_SIZE=0x2000
-CONFIG_SYS_EXTRA_OPTIONS="SYS_SDRAM_SIZE=0x20000000"
-# CONFIG_AUTOBOOT is not set
-# CONFIG_DISPLAY_CPUINFO is not set
-# CONFIG_DISPLAY_BOARDINFO is not set
-CONFIG_HUSH_PARSER=y
-CONFIG_CMD_BOOTZ=y
-CONFIG_CMD_ASKENV=y
-CONFIG_CMD_MX_CYCLIC=y
-# CONFIG_CMD_SETEXPR is not set
-CONFIG_CMD_MII=y
-CONFIG_CMD_PING=y
-CONFIG_CMD_CACHE=y
-CONFIG_CMD_TIME=y
-CONFIG_CMD_FAT=y
-CONFIG_ENV_OVERWRITE=y
-CONFIG_SYS_RELOC_GD_ENV_ADDR=y
-CONFIG_VERSION_VARIABLE=y
-CONFIG_BOUNCE_BUFFER=y
-# CONFIG_MMC is not set
-CONFIG_PHY_BROADCOM=y
-CONFIG_CONS_INDEX=3
-CONFIG_SYS_NS16550=y
-CONFIG_SHA1=y
-CONFIG_SHA256=y
-CONFIG_OF_LIBFDT=y
diff --git a/configs/bcm911360k_defconfig b/configs/bcm911360k_defconfig
deleted file mode 100644
index 7eda9a38e26f..000000000000
--- a/configs/bcm911360k_defconfig
+++ /dev/null
@@ -1,30 +0,0 @@
-CONFIG_ARM=y
-CONFIG_TARGET_BCMCYGNUS=y
-CONFIG_SYS_TEXT_BASE=0x61000000
-CONFIG_NR_DRAM_BANKS=1
-CONFIG_ENV_SIZE=0x2000
-CONFIG_SYS_EXTRA_OPTIONS="SYS_SDRAM_SIZE=0x40000000"
-# CONFIG_AUTOBOOT is not set
-# CONFIG_DISPLAY_CPUINFO is not set
-# CONFIG_DISPLAY_BOARDINFO is not set
-CONFIG_HUSH_PARSER=y
-CONFIG_CMD_BOOTZ=y
-CONFIG_CMD_ASKENV=y
-CONFIG_CMD_MX_CYCLIC=y
-# CONFIG_CMD_SETEXPR is not set
-CONFIG_CMD_MII=y
-CONFIG_CMD_PING=y
-CONFIG_CMD_CACHE=y
-CONFIG_CMD_TIME=y
-CONFIG_CMD_FAT=y
-CONFIG_ENV_OVERWRITE=y
-CONFIG_SYS_RELOC_GD_ENV_ADDR=y
-CONFIG_VERSION_VARIABLE=y
-CONFIG_BOUNCE_BUFFER=y
-# CONFIG_MMC is not set
-CONFIG_PHY_BROADCOM=y
-CONFIG_CONS_INDEX=3
-CONFIG_SYS_NS16550=y
-CONFIG_SHA1=y
-CONFIG_SHA256=y
-CONFIG_OF_LIBFDT=y
diff --git a/configs/bcm958300k-ns_defconfig b/configs/bcm958300k-ns_defconfig
deleted file mode 100644
index 06af5ce265e1..000000000000
--- a/configs/bcm958300k-ns_defconfig
+++ /dev/null
@@ -1,30 +0,0 @@
-CONFIG_ARM=y
-CONFIG_TARGET_BCMCYGNUS=y
-CONFIG_SYS_TEXT_BASE=0x61000000
-CONFIG_NR_DRAM_BANKS=1
-CONFIG_ENV_SIZE=0x2000
-CONFIG_SYS_EXTRA_OPTIONS="SYS_SDRAM_SIZE=0x40000000,ARMV7_NONSEC"
-# CONFIG_AUTOBOOT is not set
-# CONFIG_DISPLAY_CPUINFO is not set
-# CONFIG_DISPLAY_BOARDINFO is not set
-CONFIG_HUSH_PARSER=y
-CONFIG_CMD_BOOTZ=y
-CONFIG_CMD_ASKENV=y
-CONFIG_CMD_MX_CYCLIC=y
-# CONFIG_CMD_SETEXPR is not set
-CONFIG_CMD_MII=y
-CONFIG_CMD_PING=y
-CONFIG_CMD_CACHE=y
-CONFIG_CMD_TIME=y
-CONFIG_CMD_FAT=y
-CONFIG_ENV_OVERWRITE=y
-CONFIG_SYS_RELOC_GD_ENV_ADDR=y
-CONFIG_VERSION_VARIABLE=y
-CONFIG_BOUNCE_BUFFER=y
-# CONFIG_MMC is not set
-CONFIG_PHY_BROADCOM=y
-CONFIG_CONS_INDEX=3
-CONFIG_SYS_NS16550=y
-CONFIG_SHA1=y
-CONFIG_SHA256=y
-CONFIG_OF_LIBFDT=y
diff --git a/configs/bcm958300k_defconfig b/configs/bcm958300k_defconfig
deleted file mode 100644
index 7eda9a38e26f..000000000000
--- a/configs/bcm958300k_defconfig
+++ /dev/null
@@ -1,30 +0,0 @@
-CONFIG_ARM=y
-CONFIG_TARGET_BCMCYGNUS=y
-CONFIG_SYS_TEXT_BASE=0x61000000
-CONFIG_NR_DRAM_BANKS=1
-CONFIG_ENV_SIZE=0x2000
-CONFIG_SYS_EXTRA_OPTIONS="SYS_SDRAM_SIZE=0x40000000"
-# CONFIG_AUTOBOOT is not set
-# CONFIG_DISPLAY_CPUINFO is not set
-# CONFIG_DISPLAY_BOARDINFO is not set
-CONFIG_HUSH_PARSER=y
-CONFIG_CMD_BOOTZ=y
-CONFIG_CMD_ASKENV=y
-CONFIG_CMD_MX_CYCLIC=y
-# CONFIG_CMD_SETEXPR is not set
-CONFIG_CMD_MII=y
-CONFIG_CMD_PING=y
-CONFIG_CMD_CACHE=y
-CONFIG_CMD_TIME=y
-CONFIG_CMD_FAT=y
-CONFIG_ENV_OVERWRITE=y
-CONFIG_SYS_RELOC_GD_ENV_ADDR=y
-CONFIG_VERSION_VARIABLE=y
-CONFIG_BOUNCE_BUFFER=y
-# CONFIG_MMC is not set
-CONFIG_PHY_BROADCOM=y
-CONFIG_CONS_INDEX=3
-CONFIG_SYS_NS16550=y
-CONFIG_SHA1=y
-CONFIG_SHA256=y
-CONFIG_OF_LIBFDT=y
diff --git a/configs/bcm958305k_defconfig b/configs/bcm958305k_defconfig
deleted file mode 100644
index 7eda9a38e26f..000000000000
--- a/configs/bcm958305k_defconfig
+++ /dev/null
@@ -1,30 +0,0 @@
-CONFIG_ARM=y
-CONFIG_TARGET_BCMCYGNUS=y
-CONFIG_SYS_TEXT_BASE=0x61000000
-CONFIG_NR_DRAM_BANKS=1
-CONFIG_ENV_SIZE=0x2000
-CONFIG_SYS_EXTRA_OPTIONS="SYS_SDRAM_SIZE=0x40000000"
-# CONFIG_AUTOBOOT is not set
-# CONFIG_DISPLAY_CPUINFO is not set
-# CONFIG_DISPLAY_BOARDINFO is not set
-CONFIG_HUSH_PARSER=y
-CONFIG_CMD_BOOTZ=y
-CONFIG_CMD_ASKENV=y
-CONFIG_CMD_MX_CYCLIC=y
-# CONFIG_CMD_SETEXPR is not set
-CONFIG_CMD_MII=y
-CONFIG_CMD_PING=y
-CONFIG_CMD_CACHE=y
-CONFIG_CMD_TIME=y
-CONFIG_CMD_FAT=y
-CONFIG_ENV_OVERWRITE=y
-CONFIG_SYS_RELOC_GD_ENV_ADDR=y
-CONFIG_VERSION_VARIABLE=y
-CONFIG_BOUNCE_BUFFER=y
-# CONFIG_MMC is not set
-CONFIG_PHY_BROADCOM=y
-CONFIG_CONS_INDEX=3
-CONFIG_SYS_NS16550=y
-CONFIG_SHA1=y
-CONFIG_SHA256=y
-CONFIG_OF_LIBFDT=y
diff --git a/configs/bcm958622hr_defconfig b/configs/bcm958622hr_defconfig
deleted file mode 100644
index 690a613d8dc8..000000000000
--- a/configs/bcm958622hr_defconfig
+++ /dev/null
@@ -1,29 +0,0 @@
-CONFIG_ARM=y
-CONFIG_TARGET_BCMNSP=y
-CONFIG_SYS_TEXT_BASE=0x61000000
-CONFIG_NR_DRAM_BANKS=1
-CONFIG_ENV_SIZE=0x2000
-CONFIG_SYS_EXTRA_OPTIONS="SYS_SDRAM_SIZE=0x01000000"
-# CONFIG_AUTOBOOT is not set
-# CONFIG_DISPLAY_CPUINFO is not set
-# CONFIG_DISPLAY_BOARDINFO is not set
-CONFIG_HUSH_PARSER=y
-CONFIG_CMD_BOOTZ=y
-CONFIG_CMD_ASKENV=y
-CONFIG_CRC32_VERIFY=y
-CONFIG_CMD_MX_CYCLIC=y
-# CONFIG_CMD_SETEXPR is not set
-CONFIG_CMD_CACHE=y
-CONFIG_CMD_TIME=y
-CONFIG_CMD_HASH=y
-CONFIG_HASH_VERIFY=y
-CONFIG_CMD_FAT=y
-CONFIG_ENV_OVERWRITE=y
-CONFIG_SYS_RELOC_GD_ENV_ADDR=y
-CONFIG_VERSION_VARIABLE=y
-CONFIG_BOUNCE_BUFFER=y
-# CONFIG_MMC is not set
-CONFIG_SYS_NS16550=y
-CONFIG_SHA1=y
-CONFIG_SHA256=y
-CONFIG_OF_LIBFDT=y
diff --git a/include/configs/bcm_ep_board.h b/include/configs/bcm_ep_board.h
deleted file mode 100644
index ac5cc4c1c17d..000000000000
--- a/include/configs/bcm_ep_board.h
+++ /dev/null
@@ -1,51 +0,0 @@
-/* SPDX-License-Identifier: GPL-2.0+ */
-/*
- * Copyright 2014 Broadcom Corporation.
- */
-
-#ifndef __BCM_EP_BOARD_H
-#define __BCM_EP_BOARD_H
-
-#include <asm/arch/configs.h>
-
-#define CONFIG_SKIP_LOWLEVEL_INIT
-
-/*
- * Memory configuration
- * (these must be defined elsewhere)
- */
-#ifndef CONFIG_SYS_TEXT_BASE
-#error	CONFIG_SYS_TEXT_BASE must be defined!
-#endif
-#ifndef CONFIG_SYS_SDRAM_BASE
-#error	CONFIG_SYS_SDRAM_BASE must be defined!
-#endif
-#ifndef CONFIG_SYS_SDRAM_SIZE
-#error	CONFIG_SYS_SDRAM_SIZE must be defined!
-#endif
-
-#define CONFIG_SYS_MALLOC_LEN		(4 * 1024 * 1024)
-
-/* Some commands use this as the default load address */
-#define CONFIG_SYS_LOAD_ADDR		CONFIG_SYS_SDRAM_BASE
-
-/*
- * This is the initial SP which is used only briefly for relocating the u-boot
- * image to the top of SDRAM. After relocation u-boot moves the stack to the
- * proper place.
- */
-#define CONFIG_SYS_INIT_SP_ADDR		CONFIG_SYS_TEXT_BASE
-
-/* Serial Info */
-#define CONFIG_SYS_NS16550_SERIAL
-
-/* console configuration */
-#define CONFIG_SYS_CBSIZE		1024	/* Console buffer size */
-#define CONFIG_SYS_MAXARGS		64
-#define CONFIG_SYS_BARGSIZE		CONFIG_SYS_CBSIZE
-
-/* version string, parser, etc */
-
-/* Enable Time Command */
-
-#endif /* __BCM_EP_BOARD_H */